function getBitwordsPosts () {
  function getHostName(url) {
    var match = url.match(/:\/\/(www[0-9]?\.)?(.[^/:]+)/i);
    if (match != null && match.length > 2 && typeof match[2] === 'string' && match[2].length > 0)
      return match[2];
    else return null;
  }

  var $settings = document.getElementById('bitwords-settings');
  var totalNumberOfAricles = Number($settings.getAttribute('data-afterarticlesmaxstories') || 6);
  var numberOfAritclesinRow = Number($settings.getAttribute('data-afterarticlesstoresinrow') || 3);
  var isEnabled = (Number($settings.getAttribute('data-afterarticlesenabled')) || 1) == 1;
  var publisherId = $settings.getAttribute('data-publisherId');

  function createHtml (data) {
    var post = "";

    var numberOfPosts = Math.min(data.length, totalNumberOfAricles);

    for (var i = 0; i < numberOfPosts; i ++) {
      if (i === 0 || (i % numberOfAritclesinRow === 0)) { post +=  '<div class="bitwords-set">'; }

      post +=  '<a href="' + data[i].redirectUrl + '" class="bitwords-item" target="_blank">';
      post +=  '  <div class="bitwords-item-img">';
      post +=  '    <img src="' + data[i].thumbnailUrl + '" alt="' + data[i].title + '">';
      post +=  '  </div>';
      post +=  '  <div class="bitwords-title">' + data[i].title + '</div>';
      post +=  '  <div class="bitwords-domain">' + getHostName(data[i].url) + '</div>';
      post +=  '</a>';

      if (i % numberOfAritclesinRow === numberOfAritclesinRow - 1) { post +=  '</div>'; }
    }

    post += '</div>';
    return post;
  }

  if (!isEnabled) return;

  var url = "https://app.bitwords.io/api/v1/publishers/posts";
  var options = {
    headers: {
      "x-publisher": publisherId,
      "Content-Type": "application/json"
    }
  };

  // todo: convert this to XMLHttpRequest
  fetch(url, options)
    .then(res => res.json())
    .then(ads => {
      document.getElementById("bitwords-container").style.display = 'block';
      document.getElementById("bitwords-generated-list").innerHTML = createHtml(ads);
    })
}

// todo: fix this to dynamically load HTML widgets as well
getBitwordsPosts();